summaryrefslogtreecommitdiff
path: root/t/built-sources-check.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-10-27 15:26:50 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-10-27 15:27:20 +0200
commit7a3e5c7c58d5f3dab27776b5b07e3d4e1b2e5fdd (patch)
tree4e7ea408376e36673964b13884ff4f8d30a098ad /t/built-sources-check.sh
parentd26ddc825605b6b6098fcc4be5dc33ac2a8a48d1 (diff)
downloadautomake-7a3e5c7c58d5f3dab27776b5b07e3d4e1b2e5fdd.tar.gz
tests: more meaningful names for some test cases
* t/yacc5.sh: Renamed ... * t/yacc-grepping2.sh: ... like this. * t/yacc7.sh: Renamed ... * t/yacc-headers-and-pr47.sh: ... like this. * t/yacc8.sh: Renamed ... * t/yacc-subdir.sh: ... like this. * t/subdir10.sh: Rename ... * t/subdir-env-interference.sh: ... like this. * t/specflg10.sh: Rename ... * t/am-default-source-ext.sh: ... like this. * t/suffix12.sh: Rename ... * t/suffix-custom-subobj.sh: ... like this. * t/suffix13.sh: Rename ... * t/suffix-custom-subobj-and-specflg.sh: ... like this. * t/check3.sh: Rename ... * t/built-sources-check.sh: ... like this. * t/subdirbuiltsources.sh: Rename ... * t/built-sources-subdir.sh: ... like this. * t/bsource.sh: Rename ... * t/no-spurious-install-recursive.sh: ... like this. * t/list-of-tests.mk: Adjust. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/built-sources-check.sh')
-rwxr-xr-xt/built-sources-check.sh80
1 files changed, 80 insertions, 0 deletions
diff --git a/t/built-sources-check.sh b/t/built-sources-check.sh
new file mode 100755
index 000000000..3e4ce96f8
--- /dev/null
+++ b/t/built-sources-check.sh
@@ -0,0 +1,80 @@
+#! /bin/sh
+# Copyright (C) 2002-2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Make sure 'check:' and 'install:' honor $(BUILT_SOURCES).
+# PR/359.
+
+# For gen-testsuite-part: ==> try-with-serial-tests <==
+. ./defs || exit 1
+
+cat >> configure.ac << 'END'
+AC_CONFIG_FILES([dir/Makefile])
+AC_OUTPUT
+END
+
+mkdir dir
+
+cat > Makefile.am << 'END'
+BUILT_SOURCES = command1.inc
+SUBDIRS = dir
+TESTS = subrun.sh
+subrun.sh:
+ (echo '#! /bin/sh'; cat command1.inc) > $@
+ chmod +x $@
+command1.inc:
+ echo 'dir/echo.sh' > $@
+CLEANFILES = subrun.sh command1.inc
+END
+
+cat > dir/Makefile.am << 'END'
+BUILT_SOURCES = command2.inc
+check_SCRIPTS = echo.sh
+echo.sh:
+## The next line ensures that command1.inc has been built before
+## recurring into the subdir.
+ test -f ../command1.inc
+ (echo '#! /bin/sh'; cat command2.inc) > $@
+ chmod +x $@
+command2.inc:
+ echo 'echo Hello' > $@
+CLEANFILES = echo.sh command2.inc
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+./configure --prefix "$(pwd)/inst"
+
+$MAKE check >stdout || { cat stdout; exit 1; }
+cat stdout
+grep '^PASS: subrun\.sh *$' stdout
+grep 'PASS.*echo\.sh' stdout && exit 1
+
+# check should depend directly on $(BUILT_SOURCES) (similar tests
+# are in check.sh and check2.sh).
+$EGREP '^check:.* \$\(BUILT_SOURCES\)( |$)' Makefile.in
+$EGREP '^check:.* \$\(BUILT_SOURCES\)( |$)' dir/Makefile.in
+
+$MAKE clean
+# Sanity checks
+test ! -e command1.inc
+test ! -e dir/command2.inc
+# Now make sure these two files are rebuilt during make install.
+$MAKE install
+test -f command1.inc
+test -f dir/command2.inc
+
+: